Index: /trunk/src/org/expeditee/gui/AttributeValuePair.java
===================================================================
--- /trunk/src/org/expeditee/gui/AttributeValuePair.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/AttributeValuePair.java	(revision 376)
@@ -54,5 +54,6 @@
 		if (text.charAt(0) == ANNOTATION_CHAR) {
 			_bAnnotation = true;
-			if (text.length() == 1 || !Character.isLetterOrDigit(text.charAt(1)))
+			if (text.length() == 1
+					|| !Character.isLetterOrDigit(text.charAt(1)))
 				return;
 			// All chars in the attribute must be letters or digits
@@ -98,4 +99,9 @@
 	public Double getDoubleValue() throws NumberFormatException {
 		assert (_value != null);
+		// Can be null if the text for the AVP was empty
+		if (_value == null) {
+			return Double.NaN;
+		}
+
 		return _value.doubleValue();
 	}
@@ -103,5 +109,4 @@
 	public Double getDoubleAttribute() throws NumberFormatException {
 		assert (_attribute != null);
-
 		return _attribute.doubleValue();
 	}
@@ -186,3 +191,7 @@
 	}
 
+	public boolean hasAttributeOrValue() {
+		return _attribute != null || _value != null;
+	}
+
 }
Index: /trunk/src/org/expeditee/gui/Browser.java
===================================================================
--- /trunk/src/org/expeditee/gui/Browser.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/Browser.java	(revision 376)
@@ -16,4 +16,5 @@
 import java.io.File;
 import java.util.Collection;
+import java.util.LinkedList;
 
 import javax.swing.JFrame;
@@ -163,9 +164,7 @@
 		Frame defaultProfile = loadProfile(UserSettings.DEFAULT_PROFILE_NAME);
 
-		Collection<String> warningMessages = FrameUtils
-				.ParseProfile(defaultProfile);
-
+		Collection<String> warningMessages = new LinkedList<String>();
+		warningMessages.addAll(FrameUtils.ParseProfile(defaultProfile));
 		warningMessages.addAll(FrameUtils.ParseProfile(profile));
-
 		// set the layout to absolute layout for widgets
 		this.getContentPane().setLayout(new AbsoluteLayout());
@@ -239,5 +238,6 @@
 				MessageBay.warningMessage(message);
 
-			this.getContentPane().addKeyListener(FrameKeyboardActions.getInstance());
+			this.getContentPane().addKeyListener(
+					FrameKeyboardActions.getInstance());
 			this.addKeyListener(FrameKeyboardActions.getInstance());
 
Index: /trunk/src/org/expeditee/gui/DisplayIO.java
===================================================================
--- /trunk/src/org/expeditee/gui/DisplayIO.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/DisplayIO.java	(revision 376)
@@ -72,5 +72,5 @@
 	 * The title to display in the Title bar.
 	 */
-	public static final String TITLE = "Exp09Oct2008A";
+	public static final String TITLE = "Exp31Oct2008A";
 
 	private DisplayIO() {
@@ -142,13 +142,16 @@
 
 	public static void setTextCursor(Text text, int cursorMovement) {
-		setTextCursor(text, cursorMovement, false, false);
+		setTextCursor(text, cursorMovement, false, false, false, false);
 	}
 
 	public static void setTextCursor(Text text, int cursorMovement,
-			boolean newSize, boolean isShiftDown) {
+			boolean newSize, boolean isShiftDown, boolean isCtrlDown, boolean allowClearSelection) {
 
 		int size = Math.round(text.getSize());
+		if(allowClearSelection && !isShiftDown && text.hasSelection())
+			text.clearSelection();
+		
 		Point2D.Float newMouse = text.moveCursor(cursorMovement, DisplayIO
-				.getFloatMouseX(), FrameMouseActions.MouseY, isShiftDown);
+				.getFloatMouseX(), FrameMouseActions.MouseY, isShiftDown, isCtrlDown);
 
 		if (!newSize && cursorType == Item.TEXT_CURSOR) {
@@ -187,5 +190,5 @@
 
 		for (int i = start; i < cursorSize; i++)
-			pixels[i * cursorSize] = pixels[(i * cursorSize) + 1] = 0xFF000000;
+			pixels[i * cursorSize] = pixels[i * cursorSize + 1] = 0xFF000000;
 
 		Image image = Toolkit.getDefaultToolkit().createImage(
@@ -846,5 +849,5 @@
 	 */
 	public static void MoveCursorToEndOfItem(Item i) {
-		setTextCursor((Text) i, Text.END, true, false);
+		setTextCursor((Text) i, Text.END, true, false, false, false);
 	}
 
Index: /trunk/src/org/expeditee/gui/Frame.java
===================================================================
--- /trunk/src/org/expeditee/gui/Frame.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/Frame.java	(revision 376)
@@ -204,7 +204,7 @@
 		boolean oldValue = _change;
 
-		if (value) {
-			notifyObservers();
-		}
+		// if (value) {
+		// notifyObservers();
+		// }
 
 		if (oldValue == value)
@@ -219,8 +219,31 @@
 	}
 
-	public void notifyObservers() {
+	//private static int updateCount = 0;
+
+	/**
+	 * Notify items observing the data on this frame that the frame content has
+	 * changed.
+	 * 
+	 * @param recalculate
+	 *            true if the frame should be recalculated first.
+	 */
+	public void notifyObservers(boolean bRecalculate) {
+		if(bRecalculate){
+			recalculate();
+		}
 		// Notify the frame listeners that the frame has changed
-		for (FrameObserver fl : _observers) {
-			fl.update();
+		/*
+		 * Avoid ConcurrentMod Exceptions when user anchors an item onto this
+		 * frame which is observing this frame, by NOT using foreach loop.
+		 * Calling update on a dataFrameWidget resets its subjects hence
+		 * changing this frames observer list.
+		 */
+		Collection<FrameObserver> observersCopy = new LinkedList<FrameObserver>(
+				_observers);
+		//System.out.println(++updateCount + " update");
+
+		for (FrameObserver fl : observersCopy) {
+			if (/* !Item.isLocked(fl) && */fl.isVisible())
+				fl.update();
 		}
 	}
@@ -370,4 +393,9 @@
 			if (UserSettings.TitleTemplate == null) {
 				frameTitle = new Text(getNextItemID(), title);
+				/*
+				 * Need to set the parent otherwise an exception is thrown when
+				 * new profile is created
+				 */
+				frameTitle.setParent(this);
 				frameTitle.resetTitlePosition();
 			} else {
@@ -721,6 +749,7 @@
 		item.onParentStateChanged(new ItemParentStateChangedEvent(this,
 				ItemParentStateChangedEvent.EVENT_TYPE_ADDED));
-		if (recalculate && item.recalculateWhenChanged())
-			recalculate();
+
+		// if (recalculate && item.recalculateWhenChanged())
+		// recalculate();
 
 		change();
@@ -799,6 +828,6 @@
 			}
 			// TODO Improve efficiency when removeAll is called
-			if (recalculate && item.recalculateWhenChanged())
-				recalculate();
+			// if (recalculate && item.recalculateWhenChanged())
+			// recalculate();
 		}
 	}
@@ -834,4 +863,5 @@
 		Item undo = null;
 		boolean bReparse = false;
+		boolean bRecalculate = false;
 
 		if (_undo.size() <= 0)
@@ -871,4 +901,5 @@
 			for (Item i : toRestore) {
 				bReparse |= i.hasOverlay();
+				bRecalculate |= i.recalculateWhenChanged();
 				if (i instanceof Line) {
 					Line line = (Line) i;
@@ -885,4 +916,7 @@
 		if (bReparse)
 			FrameUtils.Parse(this, false);
+		else {
+			notifyObservers(bRecalculate);
+		}
 		FrameGraphics.Repaint();
 		ItemUtils.EnclosedCheck(_body);
@@ -1455,14 +1489,14 @@
 		// t.setMaxWidth(FrameGraphics.getMaxFrameSize().width);
 		// if (t.getWidth() <= 0) {
-//		String maxWidthString = getAnnotationValue("maxwidth");
-//		int width = FrameGraphics.getMaxFrameSize().width;
-//		if (maxWidthString != null) {
-//			try {
-//				width = Math.min(width, Integer.parseInt(maxWidthString));
-//			} catch (NumberFormatException nfe) {
-//			}
-//		}
-//
-//		t.setRightMargin(width);
+		// String maxWidthString = getAnnotationValue("maxwidth");
+		// int width = FrameGraphics.getMaxFrameSize().width;
+		// if (maxWidthString != null) {
+		// try {
+		// width = Math.min(width, Integer.parseInt(maxWidthString));
+		// } catch (NumberFormatException nfe) {
+		// }
+		// }
+		//
+		// t.setRightMargin(width);
 		// }
 		addItem(t);
@@ -2023,4 +2057,5 @@
 
 	public void recalculate() {
+
 		for (Item i : getItems()) {
 			if (i.hasFormula() && !i.isAnnotation()) {
@@ -2118,3 +2153,7 @@
 		}
 	}
+
+	public boolean hasObservers() {
+		return _observers != null && _observers.size() > 0;
+	}
 }
Index: /trunk/src/org/expeditee/gui/FrameGraphics.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameGraphics.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/FrameGraphics.java	(revision 376)
@@ -351,7 +351,11 @@
 		}
 
+		// if(isActual)
 		bg.setColor(backgroundColor);
-		// bg.setColor(Color.pink); // TODO: TEMP FOR DEBUGGING
-
+		if (isActualFrame){
+			//bg.setColor(Color.white); // TODO: TEMP FOR DEBUGGING
+			
+			//System.out.println("paintPic");
+		}
 		bg.fillRect(0, 0, _MaxSize.width, _MaxSize.height);
 
@@ -514,42 +518,42 @@
 	// creates a new line so that lines are shown correctly when spanning
 	// across frames in TwinFrames mode
-	private static Line TransposeLine(Line line, Item d, Frame toPaint,
-			int base, int adj) {
-		Line nl = null;
-
-		if (toPaint != DisplayIO.getCurrentFrame() && d.getParent() == null
-				&& line.getOppositeEnd(d).getParent() == toPaint) {
-			nl = line.copy();
-			if (d == line.getStartItem())
-				d = nl.getStartItem();
-			else
-				d = nl.getEndItem();
-
-			if (DisplayIO.FrameOnSide(toPaint) == 0)
-				d.setX(base);
-			else
-				d.setX(base + adj);
-
-		} else if (toPaint == DisplayIO.getCurrentFrame()
-				&& d.getParent() == null
-				&& line.getOppositeEnd(d).getParent() != toPaint) {
-			nl = line.copy();
-
-			if (d == line.getStartItem())
-				d = nl.getEndItem();
-			else
-				d = nl.getStartItem();
-
-			if (DisplayIO.FrameOnSide(toPaint) == 1)
-				d.setX(d.getX() - DisplayIO.getMiddle());
-			else
-				d.setX(d.getX() + DisplayIO.getMiddle());
-		}
-		if (nl != null) {
-			nl.invalidateAll();
-			FrameGraphics.requestRefresh(true);
-		}
-		return nl;
-	}
+	// private static Line TransposeLine(Line line, Item d, Frame toPaint,
+	// int base, int adj) {
+	// Line nl = null;
+	//
+	// if (toPaint != DisplayIO.getCurrentFrame() && d.getParent() == null
+	// && line.getOppositeEnd(d).getParent() == toPaint) {
+	// nl = line.copy();
+	// if (d == line.getStartItem())
+	// d = nl.getStartItem();
+	// else
+	// d = nl.getEndItem();
+	//
+	// if (DisplayIO.FrameOnSide(toPaint) == 0)
+	// d.setX(base);
+	// else
+	// d.setX(base + adj);
+	//
+	// } else if (toPaint == DisplayIO.getCurrentFrame()
+	// && d.getParent() == null
+	// && line.getOppositeEnd(d).getParent() != toPaint) {
+	// nl = line.copy();
+	//
+	// if (d == line.getStartItem())
+	// d = nl.getEndItem();
+	// else
+	// d = nl.getStartItem();
+	//
+	// if (DisplayIO.FrameOnSide(toPaint) == 1)
+	// d.setX(d.getX() - DisplayIO.getMiddle());
+	// else
+	// d.setX(d.getX() + DisplayIO.getMiddle());
+	// }
+	// if (nl != null) {
+	// nl.invalidateAll();
+	// FrameGraphics.requestRefresh(true);
+	// }
+	// return nl;
+	// }
 
 	private static void Paint(Graphics g, Image left, Image right,
@@ -658,5 +662,6 @@
 				if (done.contains(i))
 					continue;
-				else if (!isAudienceMode() || !i.isConnectedToAnnotation()) {
+				else if (!isAudienceMode() || 
+						!i.isConnectedToAnnotation()) {
 					toFill.add(i);
 				}
@@ -674,11 +679,11 @@
 					// System.out.println(a.getEnclosureID() + " " +
 					// b.getID());\
-					//Shapes to the left go underneath
+					// Shapes to the left go underneath
 					Polygon pA = a.getEnclosedShape();
 					Polygon pB = b.getEnclosedShape();
-					if(pA == null || pB == null)
+					if (pA == null || pB == null)
 						return 0;
-					return new Integer(pA.getBounds().x)
-							.compareTo(pB.getBounds().x);
+					return new Integer(pA.getBounds().x).compareTo(pB
+							.getBounds().x);
 				}
 				return cmp * -1;
Index: /trunk/src/org/expeditee/gui/FrameIO.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameIO.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/FrameIO.java	(revision 376)
@@ -771,4 +771,10 @@
 	}
 
+	/**
+	 * Saves a frame.
+	 * @param toSave the frame to save
+	 * @param inc true if the frames counter should be incremented
+	 * @return the text content of the frame
+	 */
 	public static String SaveFrame(Frame toSave, boolean inc) {
 		return SaveFrame(toSave, inc, true);
Index: /trunk/src/org/expeditee/gui/FrameKeyboardActions.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameKeyboardActions.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/FrameKeyboardActions.java	(revision 376)
@@ -57,4 +57,5 @@
 
 	public synchronized void keyTyped(KeyEvent e) {
+
 		if (Simple.isProgramRunning()) {
 			if (e.isControlDown()
@@ -153,8 +154,11 @@
 		}
 
-		FrameUtils.setLastEdited(text);
-
 		// if the user is in free space, create a new text item
-		if (on == null || !on.isHighlighted()) {
+		/*
+		 * MikeSays: Why do we have to check is highlighted... doing so causes
+		 * problems if you type characters to fast, they turn into multiple text
+		 * items. ie. JK together on the Linux laptop.
+		 */
+		if (on == null /* || !on.isHighlighted() */) {
 			// DisplayIO.UpdateTitle();
 			text = createText(ch);
@@ -164,5 +168,9 @@
 			DisplayIO.setTextCursor(text, Text.NONE);
 			return;
-		}
+		} else {
+			FrameUtils.setLastEdited(text);
+		}
+
+		float oldY = FrameMouseActions.MouseY;
 
 		DisplayIO.setTextCursor(text, Text.NONE);
@@ -180,4 +188,30 @@
 					FrameMouseActions.MouseY);
 		}
+		/*
+		 * check if the user hit enter and the cursor is now on another text
+		 * item
+		 */
+		if (oldY < newMouse.y) {
+			//float diff = newMouse.y - oldY;
+			// System.out.print("c");
+			Rectangle rect = text.getPolygon().getBounds();
+			
+			//Text lastEdited = FrameUtils.getLastEdited();
+			//FrameUtils.setLastEdited(null);
+			
+			Item justBelow = FrameUtils.onItem(DisplayIO.getCurrentFrame(),
+					text.getX() + 10, rect.y + rect.height + 1, false);
+			
+			//FrameUtils.setLastEdited(lastEdited);
+			
+			//Dont drop unless 
+			if (justBelow != null && justBelow instanceof Text && justBelow != on) {
+				// Drop all the items below it down!
+				// Get the list of items that must be dropped
+				List<Text> column = DisplayIO.getCurrentFrame().getColumn(on);
+				FrameUtils.Align(column, false, 0);
+			}
+		}
+
 		DisplayIO.setCursorPosition(newMouse.x, newMouse.y, false);
 
@@ -303,5 +337,5 @@
 	}
 
-	private void move(int direction, boolean isShiftDown) {
+	private void move(int direction, boolean isShiftDown, boolean isCtrlDown) {
 		Item on = FrameUtils.getCurrentItem();
 
@@ -320,7 +354,6 @@
 			} else {
 				FrameUtils.setLastEdited(text);
-				if (!isShiftDown)
-					text.clearSelection();
-				DisplayIO.setTextCursor(text, direction, false, isShiftDown);
+				DisplayIO.setTextCursor(text, direction, false, isShiftDown,
+						isCtrlDown, true);
 			}
 		}
@@ -426,8 +459,8 @@
 			break;
 		case KeyEvent.VK_LEFT:
-			move(Text.LEFT, e.isShiftDown());
+			move(Text.LEFT, e.isShiftDown(), e.isControlDown());
 			break;
 		case KeyEvent.VK_RIGHT:
-			move(Text.RIGHT, e.isShiftDown());
+			move(Text.RIGHT, e.isShiftDown(), e.isControlDown());
 			break;
 		case KeyEvent.VK_PAGE_DOWN:
@@ -441,5 +474,5 @@
 				NextTextItem(FrameUtils.getCurrentItem(), false);
 			} else {
-				move(Text.UP, e.isShiftDown());
+				move(Text.UP, e.isShiftDown(), e.isControlDown());
 			}
 			break;
@@ -448,18 +481,18 @@
 				NextTextItem(FrameUtils.getCurrentItem(), true);
 			} else {
-				move(Text.DOWN, e.isShiftDown());
+				move(Text.DOWN, e.isShiftDown(), e.isControlDown());
 			}
 			break;
 		case KeyEvent.VK_END:
 			if (e.isControlDown())
-				move(Text.END, e.isShiftDown());
+				move(Text.END, e.isShiftDown(), e.isControlDown());
 			else
-				move(Text.LINE_END, e.isShiftDown());
+				move(Text.LINE_END, e.isShiftDown(), e.isControlDown());
 			break;
 		case KeyEvent.VK_HOME:
 			if (e.isControlDown())
-				move(Text.HOME, e.isShiftDown());
+				move(Text.HOME, e.isShiftDown(), e.isControlDown());
 			else
-				move(Text.LINE_HOME, e.isShiftDown());
+				move(Text.LINE_HOME, e.isShiftDown(), e.isControlDown());
 			break;
 		// TODO remove this when upgrading Java
@@ -486,5 +519,5 @@
 		// Move the cursor to the next text item
 		Frame current = DisplayIO.getCurrentFrame();
-		Item title = current.getTitleItem();
+		Text title = current.getTitleItem();
 
 		Collection<Text> currentItems = FrameUtils.getCurrentTextItems();
@@ -494,5 +527,6 @@
 			textItems.addAll(currentItems);
 		} else {
-			textItems.add(current.getTitleItem());
+			if (title != null)
+				textItems.add(title);
 			textItems.addAll(current.getBodyTextItems(true));
 		}
@@ -504,5 +538,6 @@
 			if (title == null)
 				return;
-			DisplayIO.MoveCursorToEndOfItem(title);
+			if (title != null)
+				DisplayIO.MoveCursorToEndOfItem(title);
 			FrameGraphics.Repaint();
 			return;
@@ -634,5 +669,5 @@
 		// FrameMouseActions.pickup(t);
 		// } else {
-		// remove the link for alt+l
+		// remove the link for ctrl+l
 		Item current = FrameUtils.getCurrentItem();
 		Frame currentFrame = DisplayIO.getCurrentFrame();
@@ -641,5 +676,5 @@
 		case KeyEvent.VK_HOME:
 			if (current != null && current instanceof Text) {
-				move(Text.HOME, isShiftDown);
+				move(Text.HOME, isShiftDown, true);
 			} else {
 				while (DisplayIO.Back())
@@ -649,5 +684,5 @@
 		case KeyEvent.VK_END:
 			if (current != null && current instanceof Text) {
-				move(Text.END, isShiftDown);
+				move(Text.END, isShiftDown, true);
 			} else {
 				while (DisplayIO.Forward())
@@ -682,22 +717,32 @@
 			break;
 		case KeyEvent.VK_LEFT:
-			DisplayIO.translateCursor(-distance, 0);
+			if (current instanceof Text) {
+				DisplayIO.setTextCursor((Text) current, Text.LEFT, false,
+						isShiftDown, true, true);
+			} else {
+				DisplayIO.translateCursor(-distance, 0);
+			}
 			break;
 		case KeyEvent.VK_RIGHT:
-			DisplayIO.translateCursor(distance, 0);
+			if (current instanceof Text) {
+				DisplayIO.setTextCursor((Text) current, Text.RIGHT, false,
+						isShiftDown, true, true);
+			} else {
+				DisplayIO.translateCursor(distance, 0);
+			}
 			break;
 		case KeyEvent.VK_UP:
-			if (current instanceof Text) {
-				NextTextItem(FrameUtils.getCurrentItem(), false);
-			} else {
-				DisplayIO.translateCursor(0, -distance);
-			}
+			// if (current instanceof Text) {
+			NextTextItem(FrameUtils.getCurrentItem(), false);
+			// } else {
+			// DisplayIO.translateCursor(0, -distance);
+			// }
 			break;
 		case KeyEvent.VK_DOWN:
-			if (current instanceof Text) {
-				NextTextItem(FrameUtils.getCurrentItem(), true);
-			} else {
-				DisplayIO.translateCursor(0, distance);
-			}
+			// if (current instanceof Text) {
+			NextTextItem(FrameUtils.getCurrentItem(), true);
+			// } else {
+			// DisplayIO.translateCursor(0, distance);
+			// }
 			break;
 		case KeyEvent.VK_L:
@@ -923,5 +968,5 @@
 			Text text = getCurrentTextItem();
 			if (text == null) {
-				for (Text t : FrameUtils.getCurrentTextItems()) {
+				for (Text t : currentFrame.getBodyTextItems(false)) {
 					justify(t);
 				}
@@ -1134,5 +1179,6 @@
 			SetSize(on, repeat, true, false);
 			if (on instanceof Text) {
-				DisplayIO.setTextCursor((Text) on, Text.NONE, true, false);
+				DisplayIO.setTextCursor((Text) on, Text.NONE, true, false,
+						false, true);
 			}
 			break;
@@ -1140,5 +1186,6 @@
 			SetSize(on, -repeat, true, false);
 			if (on instanceof Text) {
-				DisplayIO.setTextCursor((Text) on, Text.NONE, true, false);
+				DisplayIO.setTextCursor((Text) on, Text.NONE, true, false,
+						false, true);
 			}
 			break;
@@ -1181,4 +1228,7 @@
 
 	private static void calculateItem(Item toCalculate) {
+		if (toCalculate == null)
+			return;
+
 		if (!toCalculate.update()) {
 			toCalculate.setFormula(null);
@@ -1421,4 +1471,5 @@
 		if (firstItem == null) {
 			firstItem = null;
+			return;
 		}
 
@@ -2187,5 +2238,5 @@
 
 		// Refresh widgets that use its self as a data source
-		currentFrame.notifyObservers();
+		currentFrame.notifyObservers(true);
 
 		if (FrameIO.isProfileFrame(currentFrame)) {
Index: /trunk/src/org/expeditee/gui/FrameMouseActions.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameMouseActions.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/FrameMouseActions.java	(revision 376)
@@ -639,4 +639,5 @@
 	private void leftButton(Item clicked, Collection<Item> clickedIn,
 			boolean isShiftDown, boolean isControlDown) {
+
 		// if the user is pointing at something then either follow the link or
 		// do TDFC
@@ -698,7 +699,9 @@
 		if (clicked != null) {
 			// check item permissions
-			if ((clicked.hasLink() && !clicked
+			boolean hasLinkOrAction = clicked.hasLink() || clicked.hasAction();
+
+			if ((hasLinkOrAction && !clicked
 					.hasPermission(Permission.followLinks))
-					|| (!clicked.hasLink() && !clicked
+					|| (!hasLinkOrAction && !clicked
 							.hasPermission(Permission.createFrames))) {
 				Item editTarget = clicked.getEditTarget();
@@ -756,5 +759,5 @@
 					tdfc(clickedOn);
 				} catch (RuntimeException e) {
-					MessageBay.errorMessage(e.getMessage());
+					MessageBay.errorMessage("TDFC error: " + e.getMessage());
 				}
 				return;
@@ -997,5 +1000,5 @@
 		} else {
 			Item on = FrameUtils.onItem(DisplayIO.getCurrentFrame(), Math
-					.round(MouseX), Math.round(MouseY));
+					.round(MouseX), Math.round(MouseY), true);
 			// If we have permission to copy this item then pick it up
 			if (on != null && on.isLineEnd()
@@ -1344,5 +1347,5 @@
 				} else {
 					Item on = FrameUtils.onItem(DisplayIO.getCurrentFrame(),
-							MouseX, MouseY);
+							MouseX, MouseY, true);
 					// if its on a line then create a line from that line
 					if (on instanceof Line && on.hasPermission(Permission.full)) {
@@ -1510,5 +1513,5 @@
 			}
 
-			DisplayIO.setTextCursor(_lastRanged, Text.NONE);
+			DisplayIO.setTextCursor(_lastRanged, Text.NONE, false, e.isShiftDown(), e.isControlDown(), false);
 			FrameGraphics.Repaint();
 			return;
@@ -1544,5 +1547,5 @@
 				&& _lastClickedOn == null && _lastClickedIn == null) {
 			Item on = FrameUtils.onItem(DisplayIO.getCurrentFrame(), e.getX(),
-					e.getY());
+					e.getY(), true);
 
 			if (FreeItems.getInstance().size() == 0) {
@@ -2162,11 +2165,13 @@
 
 	public static void delete(Item toDelete) {
+		boolean bRecalculate = false;
+
 		FrameUtils.setLastEdited(null);
 		_offX = _offY = 0;
 
-		Frame current = DisplayIO.getCurrentFrame();
+		Frame currentFrame = DisplayIO.getCurrentFrame();
 		// check if the user is pointing at the frame's framename
-		if (toDelete != null && toDelete == current.getNameItem()) {
-			current.clear(false);
+		if (toDelete != null && toDelete == currentFrame.getNameItem()) {
+			currentFrame.clear(false);
 			FrameGraphics.Repaint();
 			return;
@@ -2190,5 +2195,6 @@
 				SessionStats.DeletedItem(free);
 				// List<String> temp = anchored.getText();
-				anchored.setTextList(free.getTextList());
+				anchored.setText(free.getText());
+				anchored.setFormula(free.getFormula());
 
 				// free.setTextList(temp);
@@ -2196,4 +2202,7 @@
 
 				anchored.getParent().setChanged(true);
+
+				bRecalculate |= free.recalculateWhenChanged();
+				bRecalculate |= anchored.recalculateWhenChanged();
 
 				// update the offset since the text has changed
@@ -2206,6 +2215,4 @@
 			// reset the mouse cursor
 			updateCursor();
-			FrameGraphics.Repaint();
-			return;
 			// the user is not pointing at an item
 		} else if (toDelete == null) {
@@ -2304,4 +2311,5 @@
 				toUndo = toDelete.getConnected();
 			} else {
+				bRecalculate |= toDelete.recalculateWhenChanged();
 				toUndo = toDelete.getConnected(); // copy(toDelete.getConnected());
 			}
@@ -2318,8 +2326,12 @@
 				FrameGraphics.requestRefresh(false);
 			}
-			FrameGraphics.Repaint();
-		}
-		// check
-		DisplayIO.setCursor(Item.DEFAULT_CURSOR);
+
+			DisplayIO.setCursor(Item.DEFAULT_CURSOR);
+
+		}
+
+		currentFrame.notifyObservers(bRecalculate);
+
+		FrameGraphics.Repaint();
 	}
 
@@ -2330,4 +2342,6 @@
 	public static void deleteItems(Collection<Item> itemList, boolean addToUndo) {
 		boolean bReparse = false;
+		boolean bRecalculate = false;
+
 		SessionStats.DeletedItems(itemList);
 		List<Frame> modifiedFrames = new LinkedList<Frame>();
@@ -2339,4 +2353,5 @@
 			i.setHighlightMode(HighlightMode.None);
 			bReparse |= i.hasOverlay();
+			bRecalculate |= i.recalculateWhenChanged();
 		}
 		// If they are all free items then add the current frame
@@ -2388,6 +2403,13 @@
 		currentFrame.addAllToUndo(itemList);
 		itemList.clear();
-		if (bReparse)
+		if (bReparse) {
 			FrameUtils.Parse(currentFrame, false, false);
+			/*
+			 * TODO check if I need to recalculate even if reparse occurs, here
+			 * and in anchor, pickup etc
+			 */
+		} else {
+			currentFrame.notifyObservers(bRecalculate);
+		}
 
 	}
@@ -2558,5 +2580,6 @@
 							if (merger.size() == 1 && txt.getLink() != null) {
 								// If the text item is linked then use that
-								((WidgetCorner)mergee).setLink(txt.getAbsoluteLink(), txt);
+								((WidgetCorner) mergee).setLink(txt
+										.getAbsoluteLink(), txt);
 							} else {
 								remain.addAll(merger);
@@ -2566,5 +2589,6 @@
 							if (merger.size() == 1 && txt.getLink() != null) {
 								// If the text item is linked then use that
-								((WidgetEdge)mergee).setLink(txt.getAbsoluteLink(), txt);
+								((WidgetEdge) mergee).setLink(txt
+										.getAbsoluteLink(), txt);
 							} else {
 								remain.addAll(merger);
@@ -2608,5 +2632,7 @@
 		}
 		updateCursor();
+
 		mergee.getParent().setChanged(true);
+
 		ItemUtils.EnclosedCheck(mergee.getParent().getItems());
 		// Mike: Why does parse frame have to be called?!?
@@ -2666,6 +2692,8 @@
 
 		boolean bReparse = false;
-		Frame frame = DisplayIO.getCurrentFrame();
-		String currentFrame = frame.getName();
+		boolean bRecalculate = false;
+
+		Frame currentFrame = DisplayIO.getCurrentFrame();
+		String currentFrameName = currentFrame.getName();
 		Iterator<Item> iter = toGrab.iterator();
 		while (iter.hasNext()) {
@@ -2677,4 +2705,6 @@
 			if (i.equals(_lastHighlightedItem))
 				_lastHighlightedItem = null;
+
+			bRecalculate |= i.recalculateWhenChanged();
 			// i.setSelectedMode(SelectedMode.None);
 			// Check if it has a relative link if so make it absolute
@@ -2683,5 +2713,5 @@
 			if (i.getParent() != null) {
 				i.getParent().removeItem(i);
-				if (currentFrame.equals(i.getParent().getName()))
+				if (currentFrameName.equals(i.getParent().getName()))
 					i.setParent(null);
 			}
@@ -2704,5 +2734,6 @@
 			}
 		}
-		frame.recalculate();
+		currentFrame.change();
+
 		_lastHighlightedItem = null;
 		updateCursor();
@@ -2744,5 +2775,7 @@
 		}
 		if (bReparse)
-			FrameUtils.Parse(DisplayIO.getCurrentFrame(), false, false);
+			FrameUtils.Parse(currentFrame, false, false);
+		else
+			currentFrame.notifyObservers(bRecalculate);
 
 		FrameGraphics.Repaint();
@@ -2805,4 +2838,5 @@
 	public static void anchor(Collection<Item> toAnchor) {
 		boolean bReparse = false;
+		boolean bRecalculate = false;
 		// Need to make sure we check enclosure for overlays etc
 		Set<Frame> checkEnclosure = new HashSet<Frame>();
@@ -2827,4 +2861,5 @@
 				checkEnclosure.add(i.getParentOrCurrentFrame());
 				bReparse |= i.hasOverlay();
+				bRecalculate |= i.recalculateWhenChanged();
 			}
 		}
@@ -2834,8 +2869,12 @@
 		for (Frame f : checkEnclosure) {
 			ItemUtils.EnclosedCheck(f.getItems());
-			f.recalculate();
-		}
+		}
+
+		Frame currentFrame = DisplayIO.getCurrentFrame();
 		if (bReparse)
-			FrameUtils.Parse(DisplayIO.getCurrentFrame(), false, false);
+			FrameUtils.Parse(currentFrame, false, false);
+		else {
+			currentFrame.notifyObservers(bRecalculate);
+		}
 		FrameGraphics.Repaint();
 	}
Index: /trunk/src/org/expeditee/gui/FrameObserver.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameObserver.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/FrameObserver.java	(revision 376)
@@ -5,3 +5,5 @@
 
 	public abstract void removeSubject(Frame frame);
+	
+	public abstract boolean isVisible();
 }
